/*
 * Autor: Martin Kot
 * Funkce pro nacteni konfiguracniho souboru
 */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include "parser.h"
#include "confRead.h"
#include "confs.h"
#include "util.h"

/*
 * Rozdeli jeden radek z konfiguracniho souboru na klic a hodnotu. Nactene 
 * hodnoty se ukladaji do globalnich promennych podle confItems 
 * (viz. confRead.h)
 */
void rozdelConf(char *buffer){
  int i,j,k,l,delka,v,v2;
  char *oneVal;
  char *name;
  char **value;
  int prvku;
  k=0;
  for(i=0; buffer[i]>' ';i++);
  if(buffer[i]=='\0'){
    return;
  }
  buffer[i++]='\0';
  name=(char *)malloc((strlen(buffer)+1)*sizeof(char));
  if(name==NULL){
    LOG_ERR("HTTP","Nepodarilo se alokovat pamet");
    return;
  }
  value=NULL;
  strcpy(name,buffer);
  while(1){
    for(;buffer[i]<=' ';i++){
      if(buffer[i]=='\0'){
        if(k==0){
          free(name);
          return;
        }
        value = (char **)realloc(value, (k+1)*sizeof(char *));
        value[k++]=NULL;
        prvku=sizeof(confItems)/sizeof(confItem);
        for(l=0;l<prvku;l++){
          if(strcmp(confItems[l].nameString,name)==0){
            switch(confItems[l].type){
              case INT_ITEM:
                v=atoi(value[0]);
                v2=confItems[l].defaultValue.intValue.min;
                if(v<v2 && v2!=NO_CHECK_BOUND){
                  LOG_ERR_S("HTTP",
                    "Hodnota v konfiguracnim souboru prilis mala",
                    name);
                  v=confItems[l].defaultValue.intValue.standard;
                }
                v2=confItems[l].defaultValue.intValue.max;
                if(v>v2 && v2!=NO_CHECK_BOUND){
                  LOG_ERR_S("HTTP",
                    "Hodnota v konfiguracnim souboru prilis velka",
                    name);
                  v=confItems[l].defaultValue.intValue.standard;
                }
                *((int *)confItems[l].variable)=v;
                for(i=0;i<k-1;i++){
                  free(value[i]);
                }
                free(value);
                free(name);
                return;
                break;
              case STRING_ITEM:
                delka=strlen(value[0]);
                if(value[0][0]=='\"'&&value[0][delka-1]=='\"'){
                  oneVal=malloc((delka-1)*sizeof(char));
                  strncpy(oneVal,value[0]+1,delka-2);    
                  oneVal[delka-2]='\0';
                }
                else{
                  oneVal=strdup(value[0]);
                }
                *((char **)confItems[l].variable)=oneVal;
                for(i=0;i<k-1;i++){
                  free(value[i]);
                }
                free(name);
                return;
                break;
            }
            break;
          }
        }
        free(name);
        for(i=0;i<k-1;i++){
          free(value[i]);
        }
        free(value);
        return; 
      }
    }
    j=i;
    for(;buffer[i]>' ';i++);
    if(buffer[i]!='\0'){
      buffer[i++]='\0';
    }
    value = (char **)realloc(value, (k+1)*sizeof(char *));
    value[k++]=(char *)malloc((strlen(buffer+j)+1)*sizeof(char));
    strcpy((value)[k-1],buffer+j);
  }
}

/*
 * Precte cely konfiguracni soubor
 */
int readConfs(){
  FILE *in; 
  char *buffer;
  int bufflen,i,j;
  int znak;
  char *celeJmeno;
  if(*CONF_FILE=='/'){
    celeJmeno=strdup(CONF_FILE);
    if(celeJmeno==NULL){
      LOG_ERR("HTTP","Nepodarilo se alokovat pamet");
      return 1;
    }
  }
  else{
    celeJmeno=malloc((strlen(CONF_FILE)+strlen(SERVER_ROOT)+2)*sizeof(char));
    if(celeJmeno==NULL){
      LOG_ERR("HTTP","Nepodarilo se alokovat pamet");
      return 1;
    }
    sprintf(celeJmeno,"%s/%s",SERVER_ROOT,CONF_FILE);
  }
  printf("Nacitam soubor s konfiguraci: %s\n",celeJmeno);
  in=fopen(celeJmeno,"r");
  if(in==NULL){
    LOG_ERR_S("HTTP","Nelze otevrit soubor",celeJmeno);
    free(celeJmeno);
    return 1;
  }
  bufflen=BUFF_LEN;
  buffer=(char *)malloc((bufflen+1)*sizeof(char));
  i=0;
  while(1){
    znak=fgetc(in);
    if(znak==EOF || znak=='\n'){
      buffer[i]='\0';
      for(j=0;buffer[j]<=' '&&buffer[j]!='\0';j++);
      if(buffer[j]=='#'||buffer[j]=='\0'){
        if(znak==EOF){
          free(celeJmeno);
          fclose(in);
          return 1;
        }
        i=0;
        continue;
      }
      rozdelConf(buffer);
      if(znak==EOF){
        free(celeJmeno);
        fclose(in);
        return 1;
      }
      i=0;
    }
    else {
      buffer[i++]=znak;
      if(i==bufflen){
        bufflen*=2;
        buffer=(char *)realloc(buffer,(bufflen+1)*sizeof(char));
      }
    }
  }
  free(celeJmeno);
  fclose(in);
  return 0;
}

/*
 * Nastavi defaultni hodnoty a potom nacte konfiguracni soubor
 */
void setConfs(char *servRoot, char *confFile){
  int l;
  int prvku;
  prvku=sizeof(confItems)/sizeof(confItem);
  for(l=0;l<prvku;l++){
    switch(confItems[l].type){
      case INT_ITEM:
        *((int *)confItems[l].variable)=
		confItems[l].defaultValue.intValue.standard;
        break;
      case STRING_ITEM:
        *((char **)confItems[l].variable)=confItems[l].defaultValue.strValue;;
        break;
    }
  }  
  if(servRoot!=NULL){
    confServerRoot=servRoot;
  }
  if(confFile!=NULL){
    confConfigFile=confFile;
  }
  readConfs();
} 

#ifdef CONF_FILE_CHECK
/*
 * Umoznuje vypsat hodnoty v konfiguracnim souboru
 */
int main(int argc, char **argv){
  int l;
  int prvku;
  prvku=sizeof(confItems)/sizeof(confItem);
  setConfs(argv[1],argv[2]);
  for(l=0;l<prvku;l++){
    switch(confItems[l].type){
      case INT_ITEM:
        printf("%s = %d\n",confItems[l].nameString,*((int *)confItems[l].variable));
        break;
      case STRING_ITEM:
        printf("%s = %s\n",confItems[l].nameString,*((char **)confItems[l].variable));
        break;
    }
  }
  return 0;  
} 
#endif
