typedef enum {INT_ITEM,STRING_ITEM} CONF_ITEM_TYPES;
typedef struct {
  int standard;
  int min;
  int max;
} intDefVal;
typedef union{
  char *strValue;
  intDefVal intValue;
} defVal;

typedef struct {
  const char *nameString;  //Jmeno polozky v souboru
  void *variable;          //Globalni promenna, do niz se ulozi hodnota
  CONF_ITEM_TYPES type;    //Datovy typ promenne
  defVal defaultValue;     //Defaultni hodnota 
} confItem;
#define NO_CHECK_BOUND -1
int confPort;
int confTimeout;
int confMaxClients;
char *confDocRoot;
char *confServerRoot;
char *confDefaultType;
char *confDirectoryIndex;
char *confTypesConfig;
char *confConfigFile;
char *confCustomLogFile;
char *confErrorLogFile;
confItem confItems[]={
	{"Port",&confPort,INT_ITEM,(defVal)((intDefVal){2080,1,65535})},
	{"Timeout",&confTimeout,INT_ITEM,
		(defVal)((intDefVal){15,1,NO_CHECK_BOUND})},
	{"MaxClients",&confMaxClients,INT_ITEM,(
		defVal)((intDefVal){5,1,NO_CHECK_BOUND})},
	{"DocumentRoot",&confDocRoot,STRING_ITEM,(defVal)DEFAULT_DOC_ROOT},
	{"ConfigFile",&confConfigFile,STRING_ITEM,(defVal)DEFAULT_CONFIG_FILE},
	{"CustomLog",&confCustomLogFile,STRING_ITEM,(defVal)((char*)NULL)},
	{"ErrorLog",&confErrorLogFile,STRING_ITEM,(defVal)((char*)NULL)},
	{"ServerRoot",&confServerRoot,STRING_ITEM,(defVal)DEFAULT_SERVER_ROOT},
	{"DefaultType",&confDefaultType,STRING_ITEM,(defVal)"text/plain"},
	{"DirectoryIndex",&confDirectoryIndex,STRING_ITEM,(defVal)"index.html"},
	{"TypesConfig",&confTypesConfig,STRING_ITEM,(defVal)DEFAULT_MIME_FILE}
};

