/*
 * Autor: Martin Kot
 * Funkce pro nacteni souboru s mime typy
 */
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "confs.h"
#include "mime.h"
#include "util.h"

mimeTypes mts;
/*
 * Rozdeli jeden radek souboru na typ a pripony
 */
mimeType *rozdel(char *buffer){
  int i,j,k;
  mimeType *mt;
  k=0;
  for(i=0; buffer[i]>' ';i++);
  if(buffer[i]=='\0'){
    return NULL;
  }
  buffer[i++]='\0';
  mt = (mimeType *)malloc(sizeof(mimeType));
  mt->typ=(char *)malloc((strlen(buffer)+1)*sizeof(char));
  mt->pripona=NULL;
  strcpy(mt->typ,buffer);
  while(1){
    for(;buffer[i]<=' ';i++){
      if(buffer[i]=='\0'){
        if(k==0){
          free(mt->typ);
          free(mt);
          return NULL;
        }
        mt->pripona = (char **)realloc(mt->pripona, (k+1)*sizeof(char *));
        mt->pripona[k++]=NULL;
        return mt; 
      }
    }
    j=i;
    for(;buffer[i]>' ';i++);
    if(buffer[i]!='\0'){
      buffer[i++]='\0';
    }
    mt->pripona = (char **)realloc(mt->pripona, (k+1)*sizeof(char *));
    mt->pripona[k++]=(char *)malloc((strlen(buffer+j)+1)*sizeof(char));
    strcpy((mt->pripona)[k-1],buffer+j);
  }
}

/*
 * Precte cely soubor s mime typy
 */
int readTypes(mimeTypes *mtypes){
  FILE *in; 
  char *buffer;
  int bufflen,i;
  char znak;
  char *celeJmeno;
  mimeType *ft;
  mtypes->typy=NULL;
  mtypes->count=0;
  if(*MIME_FILE=='/'){
    celeJmeno=strdup(MIME_FILE);
    if(celeJmeno==NULL){
      LOG_ERR("HTTP","Nepodarilo se alokovat pamet");
      return 1;
    }
  }
  else{
    celeJmeno=malloc((strlen(MIME_FILE)+strlen(SERVER_ROOT)+2)*sizeof(char));
    if(celeJmeno==NULL){
      LOG_ERR("HTTP","Nepodarilo se alokovat pamet");
      return 1;
    }
    sprintf(celeJmeno,"%s/%s",SERVER_ROOT,MIME_FILE);
  }
  LOG_ERR_S("HTTP-info","Nacitam soubor s MIME typy:",celeJmeno);



  in=fopen(celeJmeno,"r");
  if(in==NULL){
    LOG_ERR_S("HTTP","Nelze otevrit soubor",celeJmeno);
    return 0;
  }
  bufflen=BUFF_LEN;
  buffer=(char *)malloc((bufflen+1)*sizeof(char));
  i=0;
  while(1){
    znak=fgetc(in);
    if(znak==EOF || znak=='\n'){
      if(buffer[0]=='#'){
        i=0;
        continue;
      }
      buffer[i]='\0';
      ft=rozdel(buffer);
      if(ft==NULL){
        if(znak==EOF){
          fclose(in);
          return 1;
        }
        i=0;
        continue;
      }
      mtypes->typy = (mimeType**) realloc(mtypes->typy,
	((mtypes->count)+1)*sizeof(mimeType*));
      mtypes->typy[(mtypes->count)++]=ft;
      if(znak==EOF){
        fclose(in);
        return 1;
      }
      i=0;
    }
    else {
      buffer[i++]=znak;
      if(i==bufflen){
        bufflen*=2;
        buffer=(char *)realloc(buffer,(bufflen+1)*sizeof(char));
      }
    }
  }
  fclose(in);
  return 0;
}

/*
 * K dane pripone souboru vraci mime typ
 */
char *extToType(char *ext){
  int i,j;
  for(i=0;i<mts.count;i++){
    for(j=0;(mts.typy[i]->pripona)[j]!=NULL;j++){
      if(strcasecmp((mts.typy[i]->pripona)[j],ext)==0){
        return mts.typy[i]->typ;
      }
    }
  }
  return DEFAULT_MIME_TYPE;
}
