#ifndef __PARSER_H
#define __PARSER_H
  #define COMM_MAX_LEN 10
  #define OPT_MAX_LEN 1024
  #define SHORT_BUFF 10
  #define FIRST_VERS_MAJOR 0
  #define FIRST_VERS_MINOR 9
  #define HTTP_PROTOCOL "HTTP"
  #define HTTP_S_PARAMS "d:hf:"
  #define DEFAULT_SERVER_ROOT ".."
  #define DEFAULT_CONFIG_FILE "conf/httpserv.conf"
  #define DEFAULT_MIME_FILE "conf/mime.types"
  #define DEFAULT_DOC_ROOT "../data"
  
  typedef enum {GET,PUT,POST,HEAD,DELETE,LINK,UNLINK,ERROR} REQUEST_TYPES;
  
  typedef enum {HTTP_OK,
  	HTTP_CREATED,
  	HTTP_BAD_REQUEST,
  	HTTP_NO_PERMISSION,
  	HTTP_REQUEST_TIMEOUT,
  	HTTP_NOT_FOUND,
  	HTTP_NOT_IMPLEMENTED,
  	HTTP_SERVICE_UNAVAILABLE
  } HTTP_ERR_CODES;
  
  typedef struct{
    char *name;
    char *value;
  }option;
  
  typedef struct{
    option *opt;
    int count;
  }options;
  
  typedef struct{
    REQUEST_TYPES type;
    char *path;
    char *params;
    char *mimeType;
    int major;
    int minor;
    options opts;
  }request;
  
  int command(char *buffer,int length, request *req);
  int path(char *buffer,int length, request *req, int pos);
  int version(char *buffer,int length, request *req, int pos);
  int optParser(char *buffer,int length, request *req, int pos);
  int analyzuj(char *bufferTCP,int length, request *req);
  void errorRequest(FILE *socketFile,HTTP_ERR_CODES errCode,request *req);
  int ansfer(FILE *socketFile,char *bufferTCP,int length);
  char *extToType(char *ext);
  void writeHeader(FILE *socketFile,request *req, int code,int contLen,
  	char *ost);
#endif
