#include "util.h"

/** 
 * @param buff		buffer s daty, pro ktery se kont. soucet pocita	
 * @param buffLen	velikost bufferu
 * @param cs_orig_neg 	bitove negovany puvodni CSUM nebo 0 pro zadny
 */
int inet_cksum(unsigned short *buff, int buffLen, unsigned short cs_orig_neg) {
	register long		sum=cs_orig_neg;	
	unsigned short		oddbyte;
	register unsigned short	ans;		

	while (buffLen > 1)  {
		sum += *(buff++);
		buffLen -= 2;
	}

	if (buffLen == 1) {
		oddbyte = 0;		
		/* one byte only */
		*((unsigned char *) &oddbyte) = *(unsigned char *)buff; 
		sum += oddbyte;
	}

	sum  = (sum >> 16) + (sum & 0xffff);	/* add high-16 to low-16 */
	sum += (sum >> 16);			/* add carry */
	ans = ~sum;		/* ones-complement, then truncate to 16 bits */
	return(ans);
}
