#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "util.h"
#define HEX_PREF "%05x "

/* Hexa cislice */
char * hexdig= "0123456789ABCDEF";

char *  hexa2bytes(const char * hexastr, int * patlen) {
    int cnt, i;
    char * pat;

    if (hexastr == NULL) { return NULL; } /* Neni-li co konvertovat */
    
    cnt = strlen(hexastr)/2;

    if (strlen(hexastr) < 2) { /* Neni alespon 1 bajt */
      LOG_ERR_S("hexa2str", "Retezec je prilis kratky", hexastr);
      if (patlen) { *patlen = 0; }
      return NULL;
    }	    
    
    pat = (char *) malloc(cnt+2);
    for (i=0; i < cnt; i++) {
       char * upper=strchr(hexdig, toupper(hexastr[2*i]));
       char * lower=strchr(hexdig, toupper(hexastr[(2*i)+1]));
       if (lower == NULL || upper == NULL) {
         LOG_ERR_S("hexa2str", "V retezci neni sestnactkove cislo", hexastr);
	 free(pat);
         if (patlen) { *patlen = 0; }
	 return NULL;
       } else {     
	 pat[i] = (((upper-hexdig) << 4) + (lower-hexdig));
       }
    }
#if UDEBUG & 2    
    fprintf(stderr, "Vzorek je: \'");
    for (i=0; i < cnt; i++) {
      fprintf(stderr, "%x", pat[i]);
    }
    fprintf(stderr,"\'\n");
#endif    
    if (patlen != NULL) { *patlen = cnt; } /* Strlen by uz nemuselo pomoct */   
    return pat;
}    

void hexshow(FILE * outf, unsigned char * data, unsigned int size, char cut) {
  register unsigned int i, s1 = size-1, s2 = ((size-1)/16 +1) * 16;
  register int elem;

  if (! size) { /* Prazdny vstup -> nic */
    return;
  }

  for(i=0, elem=1; i < s2; i++, elem++) {
    if ( ! (i & 0xf) ) {
      fprintf(outf, HEX_PREF, i);
    }
    if ( i < size) {
      fputc(hexdig[(data[i] & 0xf0) >> 4], outf);
      fputc(hexdig[(data[i] & 0xf)], outf);
    } else if (i < s2-1) {
      fputs("   ", outf);
    } else {
      fputs("  ", outf);
    }
    if (elem == 16) { /* Vypis nekodovanych znaku */
      register char j, k=0;
      elem = 0;
      fputs(" | ", outf);
      if ( i > s1 ) {
	      k = s1 - i;
      }
      for (j=-15; j <= k; j++) {
  	unsigned char c=data[i+j];
	if (c & 0xE0) { /* c > 0x20 */
	  fputc(c, outf);
	} else {
	  fputc('.', outf);
	}
      }
      fputc('\n', outf);
    } else if ( i < size) {
	fputc(' ', outf);
    }
    if ( (i % 4) == 3 && ((i+1) % 16) ) { /* Rozdelovnik */
      fputs("- ", outf);
    }
  }
  if (cut) {
    fputs("+++\n\n", outf);
  } else {
    fputc('\n', outf);
  }
}

