#ifndef __MESSAGES_H
#define __MESSAGES_H


#ifdef HTML_OUT /* !!!!!!!!!!!! HTML vystup !!!!!!!!!!!!!!! */
/*-------------------------------Spolecne--------------------------------*/
#define ERR_MSG_BEG "<font color=\"red\"><B>" 
#define ERR_MSG_END "</b></font>"

#define ERR_MSG(err) ERR_MSG_BEG err ERR_MSG_END "<br>\n"

#ifdef NO_TABLES

#  define TAB_HDR "<br><pre>"
#  define TAB_FTR "</pre><br>\n"
#  define TR(x)	      x "\n"
#  define TH(x) "<B>" x "</B> \t"
#  define TD(x)       x " \t"
#  define TDC_CS(x, cols)  TD(x)
#  define THC_CS(x, cols)  TH(x)
#  define TDC(x)      	   TD(x)

/* Konec radku v tabulce */
#define M_EOTL "<br>\n"

/* Zacatek radku v tabulce */
#define M_BOTL ""

#else /* ! NO_TABLES */

#  define TAB_HDR "<center><table border align=\"center\">\n"
#  define TAB_FTR "</table></center>\n"
#  define TR(x) "<tr>" x "</tr>\n"
#  define TH(x) "<th>" x "</th>\n"
#  define TD(x) "<td>" x "</td>\n"
#  define TDC_CS(x, cols) "<td colspan=" #cols "><center>" x "</center></td>\n"
#  define THC_CS(x, cols) "<th colspan=" #cols "><center>" x "</center></th>\n"
#  define TDC(x) TD("<center>" x "</center>")

/* Konec radku v tabulce */
#define M_EOTL "</tr>\n"

/* Zacatek radku v tabulce */
#define M_BOTL "<tr>\n"

#endif /* NO_TABLES*/

/* Vypis chyby v tabulce */
#define ERR_MSG2(err, cs) TR(TDC_CS(ERR_MSG_BEG err ERR_MSG_END, cs))

/* Jen IP adresa %s ciloveho stroje */		    
#define M_IP_ONLY TDC_CS("<b>%s</b>", 2)
		    
/* Nazev %s(1) a IP adresa %s(2) ciloveho stroje */		    
#define M_IP_HOST TDC("<b>%s</b>") TDC("%s")

/* Vypisem chybove ICMP zpravy */		    
#define M_ICMP_MSG ERR_MSG2("%s", 2)

/*-------------------------------PING-----------------------------------*/
/* Hlavicka Pingu host %s(1) s IP adresou %s(2) : %d(3) dat %d(4) dat 
   vcetne hlavicky 
*/
#define M_PING_HEAD "<h1>PING %s (%s)</h1>\n" 				\
                    "<b>Velikost dat:</b> &nbsp; %d bajtu " 		\
		    "(%d bajtu vcetne hlavicek)<br>\n" 			\
		    TAB_HDR TR(TH("Host") TH("IP adresa") TH("Seq#") 	\
  		               TH("TTL") TH("RTT") 			\
			       TH("Pozn."))

/* Ukonceni tabulky */
#define M_PING_FTR	TAB_FTR

/* Prijato %i bajtu */			    
#define M_PINFO_BYTES M_BOTL /* Vynechame */		       

/* Informace o prichozi odpovedi sekvencni cislo %i(1), TTL %i(2), cas %s(3),
   jde o duplikat? %s(4)
*/		       
		    
#define M_PINFO_INF TDC("%i") TDC("%i") TDC("%s") TDC("%s") M_EOTL

/* Zahlavi: statistiky hostu %s */			    
#define M_RTT_STATS    "<h2>Statistiky %s</h2>\n" TAB_HDR

/* Odeslano %i(1) / prijato %i(2) */    
#define M_RTT_SNDREC	TR(TH("Odeslano") TDC("%i")) \
			TR(TH("Prijato") TDC("%i"))
			    
/* Duplikovano %i */    
#define M_RTT_DUPS	TR(TH("Duplikatu") TDC("%i")) 
			    
/* S chybnym CRC %i */    
#define M_RTT_CRCS	TR(TH("Poskozeno") TDC("%i"))
			    
/* Chybovych %i */    
#define M_RTT_ERRS	TR(TH("Chybovych") TDC("%i")) 
			    
/* Ztraceno %i */    
#define M_RTT_LOST	TR(TH("Ztraceno") TDC("%i %%")) TAB_FTR

/* RTT min %f(1), avg %f(2), max %f(3) */			
#define M_RTT_RTTS	"<h3>Casove udaje</h3>\n" TAB_HDR 		  \
		         TR(TH("RTT minimalni") TH("RTT prumerny") 	  \
			 TH("RTT maximalni"))				  \
			 TR(TDC("%.3f ms") TDC("%.3f ms") TDC("%.3f ms")) \
			 TAB_FTR
			
/*------------------------------TRACEROUTE-------------------------------*/
/* Hlavicka Traceroute host %s(1) s IP adresou %s(2) max. TTL %d(3) 
   %d(4) dat preneseno. ! %i(5): pocet jednotlivych casu !
*/
#define M_TRACERT_HEAD "<h1>TRACEROUTE %s (%s)</h1>\n" 			\
		       "<b>Paramtery:</b> maximalne %i preskoku, " 	\
		       "%d bajtu dat (vcetne hlavicek)<br>\n" 		\
		       TAB_HDR TR(TH("TTL") TH("Host") TH("IP adresa") 	\
	                          THC_CS("Potrebny cas (RTT)", %i))
/* A takovehle hnusarny bych radsi vubec nedelal                ^ */				  
		    
/* Ukonceni tabulky */
#define M_TRACERT_FTR	TAB_FTR
		       
/* %i - TTL pri traceroute */		    
#define M_TINFO_TTL M_BOTL TDC("<b>%i</b>")
		    
/* %s - RTT pri traceroute */		    
#define M_TINFO_TIME TDC("%s")
		    
/* TIMEOUT pri traceroute */		    
#define M_TINFO_TOUT TDC("")
		    
		       
#else /* !!!!!!!!!!!!!!!!!!!!! Textovy vystup !!!!!!!!!!!!!!!!!!!! */
/*-------------------------------Spolecne--------------------------------*/
#define ERR_MSG_BEG "--> " 
#define ERR_MSG_END " <--\n"

#define ERR_MSG(err) ERR_MSG_BEG err ERR_MSG_END
		       
/* Vypis chyby v tabulce je totozny jako u normalni chyby */
#define ERR_MSG2(err, cs) ERR_MSG(err)
		       
/* Jen IP adresa %s ciloveho stroje */		    
#define M_IP_ONLY "%s "
		    
/* Nazev %s(1) a IP adresa %s(2) ciloveho stroje */		    
#define M_IP_HOST "%s (%s) "
		    
/* Konec radku v tabulce */
#define M_EOTL "\n"

/*-------------------------------PING-----------------------------------*/
/* Hlavicka Pingu host %s(1) s IP adresou %s(2) : %d(3) dat %d(4) dat 
   vcetne hlavicky 
*/
#define M_PING_HEAD "PING %s (%s) : %d(%d) bajtu dat.\n"

/* Informace o prichozi odpovedi sekvencni cislo %i(1), TTL %i(2), cas %s(3),
   jde o duplikat? %s(4)
*/		       
#define M_PINFO_INF ": icmp_seq=%i ttl=%i cas=%s %s\n"		       

/* Prijato %i bajtu */			    
#define M_PINFO_BYTES "%i bajtu od "		       
		       
/* Zahlavi: statistiky hostu %s */			    
#define M_RTT_STATS    "--- statistiky: %s ---\n"
		      
/* Odeslano %i(1) / prijato %i(2) */    
#define M_RTT_SNDREC	"%i odeslano, %i prijato,"
		       
/* Duplikovano %i */    
#define M_RTT_DUPS	" +%i duplikovano," 
			    
/* S chybnym CRC %i */    
#define M_RTT_CRCS	" +%i poskozeno,"	
			    
/* Chybovych %i */    
#define M_RTT_ERRS	" +%i chybovych,"	
			    
/* Ztraceno %i */    
#define M_RTT_LOST	" %i%% ztraceno\n"

/* RTT min %f(1), avg %f(2), max %f(3) */			
#define M_RTT_RTTS	"round-trip min./prum./max. = %.3f/%.3f/%.3f ms"
		    
/*------------------------------TRACEROUTE-------------------------------*/
/* Hlavicka Traceroute host %s(1) s IP adresou %s(2) max. TTL %d(3) 
   %d(4) dat preneseno
*/
#define M_TRACERT_HEAD "cesta k %s (%s) : max. %i preskoku, %d B dat.\n"
		    
/* %i - TTL pri traceroute */		    
#define M_TINFO_TTL "%3i "
		    
/* %s - RTT pri traceroute */		    
#define M_TINFO_TIME " %s"
		    
/* TIMEOUT pri traceroute */		    
#define M_TINFO_TOUT " *"
		    
#endif

/* Spolecne hlasky */

/* Nenalezena IP adresa hostu %s */
#define M_IP_NOTFOUND ERR_MSG("Nelze zjistit IP adresu stroje \'%s\'")

/* Nedostatecna prava pro provedeni %s(1) na hostu %s(2) */
#define M_EXEC_PR ERR_MSG("%s \'%s\' nelze provest (nedostatecna privilegia?)")
		  
/* Host je nedostupny */
/*#define M_UNREACH ERR_MSG2("Cilovy pocitac je nedostupny", 2)*/

/* Nic neodeslano */
#define M_NOSEND ERR_MSG("Nic nebylo odeslano")		    
		    
/* Zadne statistiky */
#define M_NOSTATS ERR_MSG("Zadne statistiky nejsou k dispozici") 
		       
/* Vypisem chybove ICMP zpravy */		    
#define M_ICMP_MSG ERR_MSG2("%s", 2)

/* Vypisem chyby pri odeslani ICMP zpravy */		    
#define M_ICMP_SND ERR_MSG("Nelze odesilat ICMP zpravy, pricina: %s")

#endif /* __MESSAGES_H */
