#ifndef __PING_H
#define  __PING_H
#include "util.h"

#define PPARAMS "c:i:p:qvs:t:nh"/* Parametry prik. radku pro ping_setup()    */
extern char *optarg;		/* Argument parametru z getopt()	     */
extern int optind;		/* Pozice neparametrizov. hodnot v getopt()  */

#define DUP_WIN_SIZ 1024 	/* Sirka okna pro kontrolu duplicit          */

/* Nasobek max. rtt pro prichod doplnkovych paketu  */
#define FINAL_MULT 4	

typedef struct {
  unsigned int verbose : 1, quiet : 1, numeric : 1; 
  /*   ukecany mod^   tichy mod^    jen IP^  */
} ping_flag_t;

typedef struct {
  int replies;			/* Pocet prijatych odpovedi, po kterych skonci*/
  int wait_ms;			/* Prodleva v sekundach mezi poslanim pingu   */
  unsigned short pack_size;     /* Delka ICMP hlavicky a dat 		      */
  unsigned char ttl;		/* Time-To-Live pro ICMP zpravy               */
  ping_flag_t flags;		/* Flagy				      */
  char * pattern;		/* Retezec dvojic hexa cislic, jako vzorek 
				   pro vyplneni dat odesilane ICMP zpravy     */
  char * host;			/* Cilovy pocitac, ktery pingame	      */
} PINGER;

typedef struct {
  int trans;				/* Odeslano 			   */
  int rec;				/* Prijato  			   */
  int dups;				/* Prijato duplikatu		   */
  int errs;				/* Prijato chybovych		   */
  int crcs;				/* Prijato s chybou CRC		   */
  long long  rtt_min, rtt_all, rtt_max;	
  /* Round-trip time min^, celkem^,  max^  */
} PING_STATS;

typedef struct {
  PINGER * p;				/* Konfigurace			   */
  PING_STATS * ps;			/* Vysledky			   */
  char * data;				/* Odesilana data s ICMP hlavickou */
  int sock;				/* Soket, pres ktery posilame	   */
  unsigned short stream;		/* Identifikace ICMP streamu       */
  struct sockaddr_in * s_addr;		/* IP adresa cile v bajtovem poli  */
  int running;				/* Stavova informace, zda bezi     */
} PING_STATE;	

/* Kompletni ping - jako main */
int ping(int opt_cnt, char **opts); 

/* Osetreni signalu -> ukonceni PINGu */
void ping_stop(int sigNo);

/* Osetreni signalu od casovace -> poslani dalsi ECHO_REQUEST */
void ping_resend(int sigNo);

/* Vypis napovedy */
void ping_help();

/* Nastaveni parametru - primarne z prikazove radky */
PINGER * ping_setup(int opt_cnt, char **opts);

/*Kontrola spravnosti rozsahu parametru */
int ping_check_params(PINGER *np);

/* Informace o nastavenych volbach */
void ping_info(PINGER *p);

/* Spusteni PINGu, vystup do streamu */
PING_STATS * ping_exec(PINGER * p, FILE * outf);

/* Zpracovani 1 odpovedi */
void ping_info_update(FILE * outf, char * buffer, int buffLen,
		      struct in_addr *adr, char ttl, struct timeval *rec);

/* Statistiky PINGu do streamu */
void ping_rtt_stats(PINGER * p, PING_STATS * inf, FILE * outf);

/* Uvolni pamet drzenou v PINGER a PING_STATS */
void ping_free(PINGER * p, PING_STATS * inf); 

#endif /* __PING_H */
