#include "util.h"
#include <sys/time.h>
#include <stdio.h>

#define US_BUFF 50
#define UNITS_MAX 6
const char * units[UNITS_MAX] = { "us", "ms", "s", "min", "h", "dni"};
const int mults[UNITS_MAX] = { 1000, 1000, 60, 60, 24, 1/*Posledni delitel 1*/};


 /* Subtract the `struct timeval' values X and Y,
  storing the result in RESULT.
  Return 1 if the difference is negative, otherwise 0.  */

int timeval_subtract (struct timeval * result, struct timeval * x, 
                                                struct timeval * y) {
   /* Perform the carry for the later subtraction by updating Y. */
   if (x->tv_usec < y->tv_usec) {
     int nsec = (y->tv_usec - x->tv_usec) / 1000000 + 1;
     y->tv_usec -= 1000000 * nsec;
     y->tv_sec += nsec;
   }
   if (x->tv_usec - y->tv_usec > 1000000) {
     int nsec = (x->tv_usec - y->tv_usec) / 1000000;
     y->tv_usec += 1000000 * nsec;
     y->tv_sec -= nsec;
   }
  
   /* Compute the time remaining to wait.
      `tv_usec' is certainly positive. */
   result->tv_sec = x->tv_sec - y->tv_sec;
   result->tv_usec = x->tv_usec - y->tv_usec;
  
   /* Return 1 if result is negative. */
   return x->tv_sec < y->tv_sec;
}

/* Casove razitko na pocet mikrosekund */
long long tv2usecs (struct timeval * tv) {
  long long tvus = tv->tv_sec;
  tvus *= 1000000;
  return (tvus += tv->tv_usec); 
}	

/* Vypis v mikrosekundach/milisekundach/sekundach */
const char * usecs2str (long long usecs) {
  static char buff [US_BUFF];
  char negative = FALSE;
  int i;
  long long j=1;

  if ( usecs < 0) { /* Zaporna hodnota */
    negative = TRUE;
    usecs = - usecs;
  }

  for (i=0; i < UNITS_MAX; i++) {
    if ((usecs/(float)j) < mults[i]) { 
       break;	    
    } else {
      j *= mults[i];
    }	    
  }	  
  if (i == UNITS_MAX) { i--; }

  if (negative == TRUE ) { usecs = -usecs; } /* Opet zpet zapornou hodnotu */

  if (j == 1) { /* Zakladni jednotky */
    sprintf(buff, "%i %s", (int)usecs, units[i]);
  } else {
    sprintf(buff, "%.3f %s", usecs/(float)j, units[i]);
  }
  return buff;
}	
