#ifndef __UTIL_H
#define  __UTIL_H
#include <sys/time.h>
#include <stdio.h>
#include <string.h>

#define DEV_NULL "/dev/null"
#define SOCK_BUFF 0x20000       /* Velikost bufferu pro prichozi zpravy      */ 

#if defined(EDEBUG) && ! defined(ERR_TRESHOLD)
#  define ERR_TRESHOLD (0x2FFFFFFF)
#endif

extern int errno;

/* Odecteni 2 casovych razitek */
int timeval_subtract (struct timeval * result, struct timeval * x,
                                                struct timeval * y);
#define tv_sub(out,in) (timeval_subtract(out,out,in))

/* Casove razitko na pocet mikrosekund */
long long tv2usecs (struct timeval * x);

/* Vypis v mikrosekundach/milisekundach/sekundach */
const char * usecs2str (long long usecs);

#ifndef STRDP 
  char * strdup(const char *);
#endif

/* Prevod retezce dvojic hexa cislic na pole bajtu */
char *  hexa2bytes(const char * hexastr, int * patlen);

/* Vypis (Dump) dat urcene delky do streamu - cut: oriznuta data*/
void hexshow(FILE * outf, unsigned char * data, unsigned int size, char cut);

/* Internetovy kontrolni soucet */
int inet_cksum(unsigned short *buff, int buffLen, unsigned short cs_orig_neg);

enum {FALSE=0, TRUE=1, IGNORE=2};
#ifndef HTTP_LOG
  #define LOG_ERR(kde,co) fprintf(stderr, "[%s] %s\n", kde, co) 
  #define LOG_ERR_P(kde,co) fprintf(stderr, "[%s] %s: %s\n", kde,\
		                                       co,strerror(errno)) 
  #define LOG_ERR_S(kde,co,param) fprintf(stderr, "[%s] %s: %s\n", kde,\
		 						co, param)
  #define LOG_ERR_I(kde,co,param) fprintf(stderr, "[%s] %s: %d\n", kde,\
		  						co, param)
#else
  void logErr(const char *kde, const char *co);
  void logErrStr(const char *kde, const char *co, const char *param);
  void logErrInt(const char *kde, const char *co, const int param);
  #define LOG_ERR(kde,co) logErr(kde,co)
  #define LOG_ERR_P(kde,co) logErrStr(kde, co, strerror(errno))
  #define LOG_ERR_S(kde,co,param) logErrStr(kde, co, param)
  #define LOG_ERR_I(kde,co,param) logErrInt(kde, co, param)
#endif	
#endif /* __UTIL_H */
