#include "init.h"
#include "funkce.h"
#include "util.h"
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <getopt.h>
#include <unistd.h>

#define DELAY_TCP 0000000L
#define DELAY_UDP 0000000L

#define SOCKET_MIN_VAL 16384

#define BUF_SOCKET 164000	// velikost bufferu schranky

#define MAX_CONNECTIONS 5       // max pocet otevr. connections

#define SPARAMS "p:s:h?" /* Port, velikost schranky, help */

int servPort, buffSocket,sel;
int  bufLenTCP = SOCKET_MIN_VAL;
int  bufLenUDP = SOCKET_MIN_VAL;
struct timeval *tv, tvpom;
FILE *file;

void end_son(int sigNo) {
  waitpid(-1,NULL,WNOHANG);
}

//.............................................................................

int ServerProtocolTCP(void) {
    struct sockaddr_in serv_addr, cli_addr;
    int clilen;
    int lenTCP;  	// pocet prectenych bytu ze vstupu
    char *bufferTCP;  	//  vystupni buffer
    int pidTCP;		// pid pro fork
    int sockfdtcp, newsockfdtcp;
    static int ID = 0;
    int re_val=1;
    int odeslano,odes;
    printf("[TCP] - start [%d]\n", ID);

    tv=&tvpom;

    if ((sockfdtcp = socket(AF_INET, SOCK_STREAM, 0)) < 0) { //otevreni socketu pro TCP
       printf("[TCP] - nemohu otervrit socket [%d]\n", ID);
       return 1;
    }

    printf("***********\n");
    setsockopt(sockfdtcp, SOL_SOCKET, SO_RCVBUF, &buffSocket, sizeof(buffSocket));
    setsockopt(sockfdtcp, SOL_SOCKET, SO_REUSEADDR, &re_val,sizeof(re_val));	
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(servPort);

    if (bind(sockfdtcp, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
       printf("[TCP] - nemohu provest 'bind' [%d]\n", ID);
       return 1;
    }

    listen(sockfdtcp, MAX_CONNECTIONS);  //poslech max. 5 spojeni (?)

    clilen = sizeof(cli_addr);

    signal(SIGCHLD, end_son);

    // Pockej na spojeni od klientu a odpovidej.
    for ( ; ; ) {
	printf("[TCP] - cekam na 'accept' [%d]\n", ID);
	newsockfdtcp = accept(sockfdtcp,(struct sockaddr *) &cli_addr, &clilen);

        if (newsockfdtcp < 0) {
	    printf("[TCP] - chyba pri 'accept' [%d]\n", ID);
	    continue; 
	}
	pidTCP = fork();
	
        if (pidTCP < 0) { //chyba pri fork
	    printf("[TCP] - Chyba pri 'fork'"); 	
	    exit(1);  
	}  
	if (pidTCP > 0) { //otec
	    close(newsockfdtcp);
	    continue;
	}  
	//nasleduje detsky proces
	bufferTCP = (char *) malloc((bufLenTCP+1) * sizeof(char));
        
	close(sockfdtcp); //uzavri puvodni socket
        for ( ; ; ) {
	    lenTCP = read(newsockfdtcp, bufferTCP, bufLenTCP); //cteni dat
	    if (lenTCP==0) break;
	    odeslano=0;
	    while(odeslano<lenTCP) {
	      odes=write(newsockfdtcp, bufferTCP, lenTCP-odeslano);
	      odeslano+=odes;
	    }//end while
        } // end for
        break;
    } // end for
    return 0;
}

//.............................................................................

int ServerProtocolUDP(void) {
    fd_set rfds,wfds; //struktura pro popis struktury FileDes.
    struct sockaddr_in serv_addr, cli_addr;
    int cli_len,sel;
    int lenUDP; // pocet prectenych bytu ze vstupu
    char *bufferUDP,*buff;  // vstupni buffer
    int pidUDP;
    int sockfdudp;
    static int ID = 0;
    struct timeval *tv, tvpom, ttmp;
    int ir=0,count,dead=0,deadly_mod=FALSE,killemall=FALSE;

    tv = &tvpom;

    printf("[UDP] - start [%d]\n", ID);
    childs=0; //pocet synu pri echu =0

    if ((sockfdudp = socket(AF_INET, SOCK_DGRAM, 0)) < 0) { //otevreni socketu pro UDP
       printf("[UDP] - nemohu otervrit socket [%d]\n", ID);
       return 1;
    }

    setsockopt(sockfdudp, SOL_SOCKET, SO_RCVBUF, &buffSocket, sizeof(buffSocket));
    setsockopt(sockfdudp, SOL_SOCKET, SO_SNDBUF, &buffSocket, sizeof(buffSocket));


    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(servPort);

    if (bind(sockfdudp, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
       printf("[UDP] - nemohu provest 'bind' [%d]\n", ID);
       return 1;
    }
    bufferUDP = (char *) malloc((bufLenUDP+1) * sizeof(char));
    buff= (char *) malloc((10) * sizeof(char));
    cli_len = sizeof(cli_addr);

    fcntl(sockfdudp,F_SETFL,O_NONBLOCK);
//**************************************************	
    FD_ZERO(&rfds);
    FD_SET(sockfdudp,&rfds);
    FD_ZERO(&wfds);
    FD_SET(sockfdudp,&wfds);
//**************************************************
    for(;;){
	sel=select(sockfdudp+1,&rfds,NULL,NULL,NULL);
	switch(sel){
           case -1: fprintf(stderr,"Chyba v otcove selektu\n");
                    break;
           case  0: printf("nic nedoslo\n");break;
	   case  1: gettimeofday(tv, NULL);
		    lenUDP = recvfrom(sockfdudp, bufferUDP, bufLenUDP, 0,
				      (struct sockaddr *)&cli_addr, &cli_len);
                    if (ioctl(sockfdudp, SIOCGSTAMP, &ttmp) >= 0) { *tv = ttmp;}
		    
#ifdef DEBUG3
                    printf("server count=%d\n",count);
#endif
//                    printf("receive %d\n",lenUDP);
		    if (lenUDP==-1) {
		       killemall=TRUE; /*Client prestal posilat, tak zrusim syny*/
		       printf("nothing %d\n",ir);
		       perror("Chyba");
		    }	
                    /*Pro pripad, ze cte a nic tam nebylo*/
                    if (lenUDP>0) {
                      bcopy((char*)tv, bufferUDP+SERVER_TIME, 8); //zapis cas odeslani paketu
                      /*pavluv kod*/
                      //Pocet paketu, ktere ma jeste dostat od klienta
                      memcpy(&count,bufferUDP+UDP_COUNT,sizeof(int));
                      while (waitpid(-1, NULL, WNOHANG)>0) {dead++;}
                      ir++;
                      pidUDP=fork();
	            }
	            break;
	} //end switch
	if (pidUDP==0){
	   _sleep();
           sel=select(sockfdudp+1,NULL,&wfds,NULL,NULL);
   	   switch(sel){
              case -1: fprintf(stderr,"Chyba v synove selektu\n");
                       exit(1);
                       break;
              case  0: printf("Nic neodeslo\n");exit(1);break;
	      case  1: gettimeofday((struct timeval*)
				      (bufferUDP+SERVER_TIME_OUT), NULL);
	               sendto(sockfdudp, bufferUDP, lenUDP, 0, 
			       (struct sockaddr *)&cli_addr, sizeof(cli_addr));
	               exit(1);
	               break;
           } //end switch
           printf("**********************************\n");
	} //end if
        if (count==0 || killemall==TRUE) {
          printf("cleaning in progress\n");
          printf("dead=%d, ir=%d, count=%d\n",dead,ir,count);
          killemall=FALSE;
          deadly_mod=FALSE;
          while(dead<ir) {
             if (waitpid(-1, NULL, WNOHANG)>0) {
                dead++;
               // ir--;
             }
          }//end while
          printf("dead=%d, ir=%d, count=%d\n",dead,ir,count);
          dead=0;
          ir=0;

        }//end if
    } //end for
    return 1;
}

//.............................................................................
void server_help(const char * name) {
  fprintf(stderr, "Uziti: %s [-p port] [-s vyr_pamet_schranky]\n\n"
          "  -p port\t port (TCP, UDP) na nemz bude server ocekavat pozadavky"
	  "\t[%i]\n"
          "  -s bajtu\t velikost vyrovnavaci pameti schranky soketu"
	  "\t\t[%i]\n"
	  , name, SERV_PORT, BUF_SOCKET
  );	  
  exit(1);
}	

//.............................................................................
/**
 * Paramtery: [Port [Buffer_size]]
 */

//int main(int argc, char *argv[], char *env[]) {
int main(int argc, char *argv[]) {

    pid_t pid;

    char c;
    
    servPort = SERV_PORT;
    buffSocket = BUF_SOCKET;	

    while ((c=getopt(argc, argv, SPARAMS)) >= 0) {
       switch (c) {
	  case 'p':	servPort   = atoi(optarg); 
			if (servPort > 65535 || servPort <= 0) {
			  servPort = SERV_PORT;
			  fprintf(stderr, "Cislo portu musi byt v "
					  "rozsahu 1-65535 "
		          );
			}	
		   	break;
	  case 's':	buffSocket = atoi(optarg); 
			if (buffSocket < SOCKET_MIN_VAL) {
			  buffSocket = SOCKET_MIN_VAL;
			  fprintf(stderr, "Minimalni velikost vyrovnavaci "
				  "pameti schranky je %i\n", SOCKET_MIN_VAL);
			}	
		   	break;
	  default:  	server_help(strrchr(argv[0],'/')+1);
       }
    }	       
			    
    bufLenTCP = buffSocket;
    bufLenUDP = buffSocket;

    printf("\n BUFFER: %d,  SERVER PORT: %d\n\n", buffSocket, servPort);

/*    processes=get_fork_info();
    printf("maximum procesu=%d\n",processes);
*/
    pid = fork();
	
    if (pid < 0) { printf("Chyba pri 'fork'"); exit(1);}  //chyba pri fork
    if (pid > 0) { ServerProtocolTCP();}
       else { ServerProtocolUDP(); }

    waitpid(pid, NULL, 0);
    return 1;

} //end main
	
